program L_line;
uses Graph, Crt;
var
  MaxX, MaxY, i : Integer;
  tg, X, Z, N, xx, yy, S, x0, k, hs, n0, k0, Angle : Real;

procedure GrInit;
var Gd, Gm, Er : Integer;
begin
  Gd:=VGA; Gm:=VGALo; DirectVideo:=false;
  InitGraph(Gd, Gm, ''); Er:=GraphResult;
  if Er<>grOk then
  begin
    WriteLn('訡  ⠭ ᪮ ०: ');
    WriteLn('   ', GraphErrorMsg(Er)); Halt(1)
  end;
  MaxX:=GetMaxX; MaxY:=GetMaxY-50
end;

procedure GetParameters;
begin
  {   砫쭮 㣫: }
  repeat
    GoToXY(1,1); TextColor(Cyan);
    Write(' 砫 㣮 ( ࠤ)       : ');
    TextColor(LightRed); ReadLn(Angle)
  until (Angle>0) and (Angle<90);
  {   ⥫ ᯮ: }
  repeat
    GoToXY(1,2); TextColor(Cyan);
    Write(' ⥫ ᯮ (0 - 0.4)   : ');
    TextColor(LightRed); ReadLn(k0)
  until (k0>0) and (k0<0.4);
  {   砫쭮  ५: }
  repeat
    GoToXY(1,3); TextColor(Cyan);
    Write(' 砫  ५ : ');
    TextColor(LightRed); ReadLn(n0)
  until (n0>=1) and (n0<100);
  {  - 㣮 ॢ  ࠤᮢ  ࠤ: }
  Angle := Angle*Pi/180
end;

procedure DrawPicture;
begin
  SetColor(LightGreen);
  { 祭  砫쭮 窥: }
  k:=0; hs:=0.1; Tg:=Sin(Angle)/Cos(Angle);
  x0:=hs*tg; S:=Sqrt(hs*hs+x0*x0)*n0;
  { ⭮⥫ ࠭ न: }
  xx:=MaxX/1000; yy:=MaxY/100;
  { ᮢ ।: }
  SetColor(LightMagenta);
  Line(70,30,70,180); Line(450,30,450,180);
  { ᮢ 砫쭮 : }
  SetColor(LightGreen);
  Line(0,MaxY+Trunc(tg*MaxY/2/Pi),70,MaxY);
  {   㣮 ࠭ - 砫 室 : }
  MoveTo(70,MaxY);
  {   -   宦 ᢥ: }
  for i:=1 to 594 do
  begin
    {  ⥫ ५: }
    N:=n0*EXP(hs*k0);
    {  न 室 ᢥ: }
    Z:=hs*hs*n0*n0+x0*x0*(N*N-n0*n0);
    X:=hs*x0*n0/SQRT(Z); K:=K+X;
    { ᮢ ⪠    न: }
    LineTo(Trunc(I*xx)+70,MaxY-Trunc(K*yy));
    { ᪨ 室 : }
    S:=S+Sqrt(hs*hs+X*X)*N;
    {  न  ⥫ ५: }
    x0:=X; n0:=N
  end;
  { ᮢ 室饣 : }
  Line(Trunc(I*xx)+70,MaxY-Trunc(K*yy),
	Trunc(800*xx)+70,MaxY-Trunc(k*yy/xx));
  repeat until KeyPressed
end;

procedure FormFile;
var Fp : Text;
begin
  { ନ஢ 䠩 : }
  Assign(Fp, 'l_line.dat'); ReWrite(Fp);
  Writeln(Fp, 'ࢠ न -   X,');
  Writeln(Fp, ' -   Y,  ');
  x0:=hs*tg; S:=Sqrt(hs*hs+x0*x0)*n0;
  for i:=1 to 120 do
  begin
    {  ⥫ ५: }
    N:=n0*EXP(hs*k0);
    {  न 室 ᢥ: }
    Z:=hs*hs*n0*n0+x0*x0*(N*N-n0*n0);
    X:=hs*x0*n0/SQRT(Z); K:=K+X;
    {   䠩 १⮢: }
    WriteLn(Fp, I:3,'   ',K*yy:1:5);
    { ᪨ 室 : }
    S:=S+Sqrt(hs*hs+X*X)*N;
    {  न  ⥫ ५: }
    x0:=X; n0:=N
  end;
  Close(Fp)
end;

begin
  GrInit; GetParameters; DrawPicture;
  CloseGraph; FormFile;
  while KeyPressed do ReadKey
end { L_line }.