(************************************************************)
(*							    *)
(*	ணࠬ  ᨫ  ⭮ 	    *)
(*		誨  ⮪ ( 9.8)		    *)
(*							    *)
(*		    !		    *)
(*							    *)
(************************************************************)
(*							    *)
(*	 祭 ࠭ ࠩ  ணࠬ :	    *)
(* 1)     BINOBJ EGAVGA.BGI EGAVGA EGAVGA_DRIV   *)
(*      ப DOS.				    *)
(* 2)   ணࠬ ᫥ ⠢ ४⨢ ᫮- *)
(*     樨 {$define IncDriver}.		    *)
(*							    *)
(************************************************************)

program Magnetism_2; { $define IncDriver}
uses Graph, Crt;
label 1;
var Choise : Char;
  Lk, Gd, Gm, Er, i, j, Vn, N : Integer;
  rx, ry, rz, Ycursor, Xcursor, Zcursor,
  dx, dy, dz, Ymax, Xmax, Aspect_Ratio,
  dl, Angle, Delta_Angle, a, Delta, b,
  St, r, b0, bx, by, bz, Xold, Yold : Real;
  x, y, z, dlx, dly, dlz : array [1..50] of Real;

{$ifdef IncDriver}
  procedure EGAVGA_Driv; {$L egavga.obj} external;
{$endif}

procedure Draw_Gr;
begin
  rx:=Xcursor; ry:=Ycursor;
  repeat
    bx:=0.0; by:=0.0; bz:=0.0;
    for j:=1 to Vn do
    begin
      Zcursor:=0.025*St*(j-1);
      for i:=1 to N do
      begin
	{ 塞 ﭨ  
	  窨  ⪠ ⮪ }
	dx:=rx-x[i]; dy:=ry-y[i]; dz:=rz-z[i];
	r:=Sqrt(Sqr(dx)+Sqr(dy)+Sqr(dz));
	b0:=1/(r*Sqr(r)); {  ⠥ ࠢ 1 A }
	{ B ய樮쭮 dL, x, r }
	bx:=bx+b0*(dly[i]*dz-dlz[i]*dy);
	by:=by+b0*(dlz[i]*dx-dlx[i]*dz);
	bz:=bz+b0*(dlx[i]*dy-dly[i]*dx)
      end;
    end;
    b:=Sqrt(Sqr(bx)+Sqr(by)+Sqr(bz));
    {  窠  ᨫ  }
    rx:=rx+Delta*bx/b; ry:=ry+Delta*by/b;
    rz:=rz+Delta*bz/b+zcursor;
{    if (ry=Abs(ry)) or (Abs(ry)>100) then Break; }
    PutPixel(320+Round(rx),100+Round(ry),Yellow);
    PutPixel(320+Round(rx),100-Round(ry),Yellow)
  until KeyPressed
end;

begin
  {$ifdef IncDriver}
    if RegisterBGIDriver(@EGAVGA_Driv)<0 then
    begin
      WriteLn('訡  ॣ樨 ࠩ'); Halt(1)
    end;
  {$endif}
  Gd:=VGA; Gm:=VGALo; DirectVideo:=false;
  InitGraph(Gd, Gm, ''); Er:=GraphResult;
  if Er<>grOk then
  begin
    WriteLn('訡  ⠭ ᪮ ०: ');
    WriteLn('   ', GraphErrorMsg(Er)); Halt(1)
  end;
  {  ⪨ ஢  ⮪ }
  { ⠥ ⮪ ࠢ   }
  TextColor(LightRed); Write('- ⪮  : ');
  TextColor(LightMagenta); ReadLn(Vn);
  if Vn<>1 then
  begin
    TextColor(LightRed); Write(' 誨  : ');
    TextColor(LightMagenta); ReadLn(Lk); St:=Lk/Vn;
    TextColor(Green); Write(' ⪠      = ');
    TextColor(Yellow); WriteLn(St:2:3)
  end;
  TextColor(LightRed); Write(' ⪠   : ');
  TextColor(LightMagenta); ReadLn(a); a:=a*16;
  TextColor(LightRed); Write('᫮ ⪮ : ');
  TextColor(LightMagenta); ReadLn(N);
  if N>50 then
  begin
    CloseGraph; TextColor(LightRed);
    WriteLn('誮  ⪮ !');
    TextColor(7); WriteLn; Halt(1)
  end;
  TextColor(LightRed); Write('Delta          : ');
    { Delta -  ⪠ ⭮ ᨫ  }
  TextColor(LightMagenta); ReadLn(Delta);
  Delta_Angle:=2*Pi/N; Angle:=0; dl:=2*Pi*a/N;
  for i:=1 to N do
  begin
    x[i]:=a*Cos(Angle); y[i]:=0; z[i]:=a*Sin(Angle);
    dlx[i]:=-dl*Sin(Angle);
      { ࠢ ⪠ ⮪  窥 (x,y,z) }
    dly[i]:=0; dlz[i]:=dl*Cos(Angle);
    Angle:=Angle+Delta_Angle
  end;
    {  ஥ ⫨  ⮪   x-y }
  1: Ymax:=3*a; Aspect_Ratio:=1.5; Xmax:=Aspect_Ratio*Ymax;
  { dx  dy -  ࠧ 蠣 }
  dx:=0.025*Xmax; dy:=0.025*Ymax;
  r:=0.01*Xmax; SetColor(Green);
  for i:=1 to Vn do
    Ellipse(320,Round(100+16*i*St),0,360,Round(a),1);
  Xcursor:=0; Ycursor:=0;
  repeat
    Choise:=#0;
    if KeyPressed then
    begin
      Choise:=ReadKey; if Choise=#0 then Choise:=ReadKey;
      Xold:=Xcursor; Yold:=Ycursor;
      PutPixel(320+Round(Xold-r),100+Round(Yold-r),Black);
      case Choise of
        #$4b: Xcursor:=Xcursor-dx;
	#$4d: Xcursor:=Xcursor+dx;
        #13: begin Draw_Gr; Break end
      end;
      PutPixel(320+Round(Xcursor-r),
        100+Round(Ycursor-r),LightCyan)
    end
  until Choise=#27 { ESC - 室  ணࠬ };
  if Choise<>#27 then goto 1 else CloseGraph
end { Magnetism_2 }.