program Polar2;
const ScanCode : Byte = 0;
var Lambda, nx, ny, dt, w, c, k, t, Width : Real;

function KeyPressed: Boolean; assembler;
asm
	cmp	ScanCode,0
	jne	@@1
	mov	ah,1
	int	16h
	mov	al,0
	je	@@2
@@1:	mov	al,1
@@2:
end;

function ReadKey: Char; assembler;
asm
	mov	al,ScanCode
	mov	ScanCode,0
	or	al,al
	jne	@@1
	xor	ah,ah
	int	16h
	or	al,al
	jne	@@1
	mov	ScanCode,ah
	or	ah,ah
	jne	@@1
	mov	al,3
@@1:
end;

procedure TestWidth;
{ 楤 뢠,   ⮫騭 ⠫
  ᢥ  室 㤥  ਧ, ᫨ 
  室  ୮ ਧ.
	⮤ ᭮  業 । 筮
	⪫ ⠭ 㣫  .
	  ਧ樨 㣮   
	,  । 筮 ⪫
	 ६  . }
const
  Nlines = 30; { ࠢ 30  }
var
  i : Integer;
  s, dw : Real;
  sa, a : array [1..30] of Real;
begin
  { 塞 砫 ᫮ }
  nx:=2; ny:=5;
  Width:=5e-5; { 砫쭠 ⮫騭 }
  Lambda:=5e-5; {   }
  k:=2*Pi/Lambda; c:=3e+11;
  w:=k*c; dt:=0.1/w;
  dw:=5e-6; { 饭 ⮫騭 ⠫ }
  repeat
    t:=0;
    { 뢠 㣫 }
    for i:=1 to Nlines do
    begin
      t:=t+dt;
      {   ᨭ ⠭ ᨭᮬ, ⠪
	 砫쭮 ᢥ ୮ ਧ 
	ᤢ 䠧 = Pi/2 }
      a[i]:=sin(w*t-k*Width/nx)/cos(w*t-k*Width/ny)
    end;
    { 뢠 । 䬥᪮ }
    s:=0;
    for i:=1 to Nlines do s:=s+a[i];
    s:=s/Nlines;
    { 뢠 । 筮 ⪫ }
    for i:=1 to Nlines do sa[i]:=sqr(s-a[i]);
    s:=0;
    for i:=1 to Nlines do s:=s+sa[i];
    s:=s/Nlines;
    { ᫨  筮  -  뢮 ⮫騭 }
    if s<1e-16 then writeln(Width);
    Width:=Width+dw
  until KeyPressed
end;

begin
  writeln('ணࠬ 뢠,   ⮫騭 ⠫');
  writeln('ᢥ  室 㤥  ਧ, ᫨ ');
  writeln('室  ୮ ਧ.'); writeln;
  TestWidth; while KeyPressed do ReadKey
end.
