(************************************************************)
(*							    *)
(*	ணࠬ ந 䨪  殮 	    *)
(*		१  ࠧ 		    *)
(*							    *)
(************************************************************)
(*							    *)
(*	 祭 ࠭ ࠩ  ணࠬ ᫥- *)
(*      BINOBJ EGAVGA.BGI EGAVGA EGAVGA_DRIV   *)
(*   ப DOS.   ணࠬ ᫥ - *)
(* ⠢ ᫮ {$define IncDriver}.			    *)
(*	 ⨢ 砥  ࠡ ணࠬ ᫥	    *)
(*  䠩 EGAVGA.BGI  ⥪饬 ⠫		    *)
(*							    *)
(************************************************************)

program RC_Graphic; { $define IncDriver}
uses Graph, Crt;
const
  r = 1000;
  c = 0.000001;
  tau = 0.001;
  Str_In = '筨 殮:';
  Str_Out = ' 殮  १:';
  Fmas : array [1..9] of Integer =
    (10, 50, 100, 160, 200, 500, 1000, 5000, 10000);
var
  dtInt, kk, v0, w, Tmax, Vmin, dt, t, q, i, v : Real;
  f, j : Integer;
  st : string[20];
  Bul : Boolean;

{$ifdef IncDriver}
  procedure EGAVGA_Driv; {$L egavga.obj} external;
{$endif}

procedure MyGraphInit;
var
  Gd, Gm, Er : Integer;
begin
  {$ifdef IncDriver}
    if RegisterBGIDriver(@EGAVGA_Driv)<0 then
    begin
      WriteLn('訡  ॣ樨 ࠩ'); Halt(1)
    end;
  {$endif}
  Gd:=VGA; Gm:=VGAHi; DirectVideo:=false;
  InitGraph(Gd, Gm, ''); Er:=GraphResult;
  if Er<>grOk then
  begin
    WriteLn('訡  ⠭ ᪮ ०: ');
    WriteLn('   ', GraphErrorMsg(Er)); Halt(1)
  end
end { MyGraphInit };

function Fun(var v0, w, t : Real) : Real;
begin
  Fun:=v0*Cos(w*t)
end;

begin
  MyGraphInit;
  for j:=1 to 9 do
  begin
    f:=Fmas[j]; v0:=1; w:=2*Pi*f;
    dt:=0.00001; t:=1/f; Bul:=false;
    if t>tau then Tmax:=2*t else Tmax:=2*tau;
    dtInt:=220*dt/Tmax;
    ClearDevice; SetColor(LightGray); Vmin:=-v0;
    Line(50,240,270,240); Line(50,140,50,340);
    Line(370,240,590,240); Line(370,140,370,340);
    TextColor(LightMagenta); GoToXY(11,5); Write(Str_In);
    TextColor(LightRed); GoToXY(45,5); Write(Str_Out);
    v0:=50; q:=0; kk:=0; GoToXY(50,8); str(Fmas[j],st);
    TextColor(Green); Write(' : ');
    TextColor(LightCyan); Write(st);
    TextColor(Green); Write(' ');
    while t<=Tmax do
    begin
      t:=t+dt; v:=Fun(v0,w,t); i:=v/r-q/tau; q:=q+i*dt;
      if (j=8) and not Bul then
      begin
	dt:=0.000002; dtInt:=220*dt/Tmax; Bul:=true
      end;
      case j of
	1..7: kk:=kk+dtInt*2;
	8..9: kk:=kk+dtInt
      end;
      PutPixel(50+Round(kk),240-Round(v),Yellow);
      PutPixel(370+Round(kk),240-Round(i*r),Yellow)
    end;
    TextColor(LightGreen); GoToXY(29,25);
    Write('   !');
    while KeyPressed do ReadKey;
    repeat until KeyPressed;
    GoToXY(29,25); Write('                       ')
  end;
  CloseGraph; while KeyPressed do ReadKey
end { RC_Graphic }.