(************************************************************)
(*							    *)
(*    ணࠬ  ᨫ  ᪮     *)
(*							    *)
(************************************************************)
(*							    *)
(*	 祭 ࠭ ࠩ  ணࠬ :	    *)
(* 1)     BINOBJ EGAVGA.BGI EGAVGA EGAVGA_DRIV   *)
(*      ப DOS.				    *)
(* 2)   ணࠬ ᫥ ⠢ ४⨢ ᫮- *)
(*     樨 {$define IncDriver}.		    *)
(*							    *)
(************************************************************)

program Field_Line; { $define IncDriver}
uses Graph, Crt;
var
  Choise : Char;
  Gd, Gm, Er : Integer;
  N, i : Byte;
  Stop_Plot : Boolean;
  q : array [1..20] of Integer;
  x, y : array [1..20] of Real;
  Xold, Yold, Ycursor, Xcursor, r, Xmax, Ymax, dx,
  dy, Ex, Ey, E0, E, Delta, Xline, Yline : Real;

{$ifdef IncDriver}
  procedure EGAVGA_Driv; {$L egavga.obj} external;
{$endif}

procedure Charges;
  procedure Write_Equ;
  begin
    TextColor(Cyan); Write(' = '); TextColor(LightRed)
  end;
begin
  TextColor(Cyan); Write('⢮ 冷 (<20)');
  Write_Equ; ReadLn(n);
  for i:=1 to N do
  begin
    if (i-1) mod 4 = 0 then
    begin
      ClearDevice; gotoxy(1,1)
    end;
    TextColor(Cyan); Write(' (ப㫮)  ');
    TextColor(LightGreen); Write(i);
    Write_Equ; ReadLn(q[i]); TextColor(Cyan);
    Write('X  Y न ()  ');
    TextColor(LightGreen); WriteLn(i); TextColor(Yellow);
    Write('X'); Write_Equ; ReadLn(x[i]);
    TextColor(Yellow); Write('Y');
    Write_Equ; ReadLn(y[i]); WriteLn;
    x[i]:=x[i]*50; y[i]:=y[i]*40;
    if Xmax<Abs(x[i]) then Xmax:=Abs(x[i]);
    if Ymax<Abs(y[i]) then Ymax:=Abs(y[i])
  end;
  if Xmax>Ymax then Ymax:=Xmax;
  Ymax:=1.5*Ymax;
  if Ymax=0 then Ymax:=2;
  ClearDevice
end;

procedure Screen;
begin
  Xmax:=1.5*Ymax; r:=0.01*Xmax;
  for i:=1 to N do
  begin
    if q[i]<0 then SetColor(LightBlue)
      else SetColor(LightRed);
    Circle(300+Round(x[i]),90+Round(y[i]),Round(r))
  end;
  dx:=0.025*Xmax; dy:=0.025*Ymax
end;

procedure Draw_Gr;
begin
  Xline:=Xcursor; Yline:=Ycursor;
  Delta:=0.1; Stop_Plot:=false;
  repeat
    Ex:=0; Ey:=0;
    for i:=1 to N do
    begin
      { ﭨ  窨  鸞 i }
      dx:=Xline-x[i]; dy:=Yline-y[i];
      r:=Sqrt(Sqr(dx)+Sqr(dy));
      if r>0.001 then
      begin
	E0:=q[i]/r*Sqr(r); Ex:=Ex+E0*dx; Ey:=Ey+E0*dy
      end
      else Stop_Plot:=true
    end;
    E:=Sqrt(Sqr(Ex)+Sqr(Ey));
    if E>0.001 then
    begin
      {   ᨫ  }
      Xline:=Xline+Delta*Ex/E; Yline:=Yline+Delta*Ey/E
    end
    else Stop_Plot:=true;
    if not Stop_Plot then
      PutPixel(300+Round(Xline),90+Round(Yline),Yellow)
  until KeyPressed or Stop_Plot
end;

procedure Move_Cursor;
label 1;
begin
  1: Screen; Xcursor:=0; Ycursor:=0;
  repeat
    Choise:=#0;
    if KeyPressed then
    begin
      Choise:=ReadKey; if Choise=#0 then Choise:=ReadKey;
      Xold:=Xcursor; Yold:=Ycursor;
      PutPixel(300+Round(Xold-r),90+Round(Yold-r),Black);
      case Choise of
	#$4b: Xcursor:=Xcursor-3;
	#$4d: Xcursor:=Xcursor+3;
	#$50: Ycursor:=Ycursor+3;
	#$48: Ycursor:=Ycursor-3;
	#13: begin Draw_Gr; Break end
      end;
      PutPixel(300+Round(Xcursor-r),
	90+Round(Ycursor-r),LightCyan)
    end
  until Choise=#27;
  if Choise<>#27 then goto 1 else CloseGraph
end;

begin
  {$ifdef IncDriver}
    if RegisterBGIDriver(@EGAVGA_Driv)<0 then
    begin
      WriteLn('訡  ॣ樨 ࠩ'); Halt(1)
    end;
  {$endif}
  Gd:=VGA; Gm:=VGALo; DirectVideo:=false;
  InitGraph(Gd, Gm, ''); Er:=GraphResult;
  if Er<>grOk then
  begin
    WriteLn('訡  ⠭ ᪮ ०: ');
    WriteLn('   ', GraphErrorMsg(Er)); Halt(1)
  end;
  Charges; Move_Cursor
end { Field_Line }.