(************************************************************)
(*							    *)
(*	ணࠬ  ᨫ  ⭮ 	    *)
(*							    *)
(************************************************************)
(*							    *)
(*	 祭 ࠭ ࠩ  ணࠬ ᫥- *)
(*      BINOBJ EGAVGA.BGI EGAVGA EGAVGA_DRIV   *)
(*   ப DOS.   ணࠬ ᫥ - *)
(* ⠢ ᫮ {$define IncDriver}.			    *)
(*	 ⨢ 砥  ࠡ ணࠬ ᫥	    *)
(*  䠩 EGAVGA.BGI  ⥪饬 ⠫		    *)
(*							    *)
(************************************************************)

program Magnetism_1; { $define IncDriver}
uses Graph, Crt;
label 1;
var Choise : Char;
  Gd, Gm, Er, i, N : Integer;
  rx, ry, rz, Ycursor, Xcursor, Zcursor,
  dx, dy, dz, Ymax, Xmax, Aspect_Ratio,
  dl, Angle, Delta_Angle, a, Delta, b,
  r, b0, bx, by, bz, Xold, Yold : Real;
  x, y, z, dlx, dly, dlz : array [1..50] of Real;

{$ifdef IncDriver}
  procedure EGAVGA_Driv; {$L egavga.obj} external;
{$endif}

procedure Draw_Gr;
begin
  rx:=Xcursor; ry:=Ycursor;
  repeat
    bx:=0.0; by:=0.0; bz:=0.0;
    for i:=1 to N do
    begin
      { 塞 ﭨ  
	窨  ⪠ ⮪ }
      dx:=rx-x[i]; dy:=ry-y[i]; dz:=Zcursor-z[i];
      r:=Sqrt(Sqr(dx)+Sqr(dy)+Sqr(dz));
      b0:=1/(r*Sqr(r)); {  ⠥ ࠢ 1 A }
      { B ய樮쭮 dL, x, r }
      bx:=bx+b0*(dly[i]*dz-dlz[i]*dy);
      by:=by+b0*(dlz[i]*dx-dlx[i]*dz);
      bz:=bz+b0*(dlx[i]*dy-dly[i]*dx)
    end;
    b:=Sqrt(Sqr(bx)+Sqr(by)+Sqr(bz));
    {  窠  ᨫ  }
    rx:=rx+Delta*bx/b; ry:=ry+Delta*by/b;
    rz:=rz+Delta*bz/b;
    PutPixel(320+Round(rx),100+Round(ry),Yellow)
  until KeyPressed
end;

begin
  {$ifdef IncDriver}
    if RegisterBGIDriver(@EGAVGA_Driv)<0 then
    begin
      WriteLn('訡  ॣ樨 ࠩ'); Halt(1)
    end;
  {$endif}
  Gd:=VGA; Gm:=VGALo; DirectVideo:=false;
  InitGraph(Gd, Gm, ''); Er:=GraphResult;
  if Er<>grOk then
  begin
    WriteLn('訡  ⠭ ᪮ ०: ');
    WriteLn('   ', GraphErrorMsg(Er)); Halt(1)
  end;
  {  ⪨ ஢  ⮪ }
  { ⠥ ⮪ ࠢ   }
  TextColor(LightRed); Write(' ⪠   : ');
  TextColor(LightMagenta); ReadLn(a);
  TextColor(LightRed); Write('᫮ ⪮ : ');
  TextColor(LightMagenta); ReadLn(N);
  TextColor(LightRed); Write('Delta          : ');
    { Delta -  ⪠ ⭮ ᨫ  }
  TextColor(LightMagenta); ReadLn(Delta);
  Delta_Angle:=2*Pi/N; Angle:=0; dl:=2*Pi*a/N;
  for i:=1 to N do
  begin
    x[i]:=a*Cos(Angle); y[i]:=0; z[i]:=a*Sin(Angle);
    dlx[i]:=-dl*Sin(Angle);
      { ࠢ ⪠ ⮪  窥 (x,y,z) }
    dly[i]:=0; dlz[i]:=dl*Cos(Angle);
    Angle:=Angle+Delta_Angle
  end;
    {  ஥ ⫨  ⮪   x-y }
  1: Ymax:=3*a; Aspect_Ratio:=1.5; Xmax:=Aspect_Ratio*Ymax;
  { dx  dy -  ࠧ 蠣 }
  dx:=0.025*Xmax; dy:=0.025*Ymax; r:=0.01*Xmax;
  SetColor(Green); Ellipse(320,100,0,360,Round(a),4);
  Xcursor:=0; Ycursor:=0;
  repeat
    Choise:=#0;
    if KeyPressed then
    begin
      Choise:=ReadKey; if Choise=#0 then Choise:=ReadKey;
      Xold:=Xcursor; Yold:=Ycursor;
      PutPixel(320+Round(Xold-r),100+Round(Yold-r),Black);
      case Choise of
        #$4b: Xcursor:=Xcursor-dx;
	#$4d: Xcursor:=Xcursor+dx;
        #$50: Ycursor:=Ycursor+dy;
        #$48: Ycursor:=Ycursor-dy;
        #13: begin Draw_Gr; Break end
      end;
      PutPixel(320+Round(Xcursor-r),
        100+Round(Ycursor-r),LightCyan)
    end
  until Choise=#27 { ESC - 室  ணࠬ };
  if Choise<>#27 then goto 1 else CloseGraph
end { Magnetism_1 }.